// IMatchFinder.cs
//  
//  Copyright (C) 2009 Bartek Jasicki based on LZMA SDK
// 
//  This file is part of Grubng
// 
//  Grubng is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 

using System;

namespace Grubng
{
	interface IInWindowStream : IDisposable
	{
		void SetStream(System.IO.Stream inStream);
		void Init();
		void ReleaseStream();
		byte GetIndexByte(int index);
		uint GetMatchLen(int index, uint distance, uint limit);
		uint GetNumAvailableBytes();
	}

	interface IMatchFinder : IInWindowStream
	{
		void Create(uint historySize, uint keepAddBufferBefore,
				uint matchMaxLen, uint keepAddBufferAfter);
		uint GetMatches(uint[] distances);
		void Skip(uint num);
	}
}
